#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>

#define DEVNAME "/dev/pidview"
#define DEVNAME2 "/dev/sda"
#define SIZE 16*1024

unsigned char buffer[SIZE];

int loop(void)
{
	int fd;
	int ret=1;
	fd = open(DEVNAME2, O_RDONLY);
	if(fd<0){
		perror(DEVNAME2);
		return 2;
	}

	while(ret>0){
		ret=read(fd, buffer, SIZE);
	}
	close(fd);
}

int main(int argc, char *argv[])
{
	int x=0;
	int fd;
	char str[16];

/* 引数 1-3 を取る */
	if(argv[1]){
		if(argv[1][0] == '1')
			x=1;
		if(argv[1][0] == '2')
			x=2;
		if(argv[1][0] == '3')
			x=3;
	}

	if(x==0){
		printf("%s [1-3]\n",argv[0]);
		return 1;
	}

/* カーネル内の変数を書き換えるドライバ */
	fd = open(DEVNAME, O_RDWR);
	if(fd<0){
		perror(DEVNAME);
		return 1;
	}
	sprintf(str,"%d\n",x);
	write(fd,str,1);	/* 1バイトwrite */
	close(fd);

/* 負荷ループ */
	loop();
}
