#define _PACR 0xA4050100 /* ポートA 制御レジスタ */
#define _PBCR 0xA4050102 /* ポートB 制御レジスタ */
#define _PCCR 0xA4050104 /* ポートC 制御レジスタ */
#define _PDCR 0xA4050106 /* ポートD 制御レジスタ */
#define _PECR 0xA4050108 /* ポートE 制御レジスタ */
#define _PFCR 0xA405010A /* ポートF 制御レジスタ */
#define _PGCR 0xA405010C /* ポートG 制御レジスタ */
#define _PHCR 0xA405010E /* ポートH 制御レジスタ */
#define _PJCR 0xA4050110 /* ポートJ 制御レジスタ */
#define _PKCR 0xA4050112 /* ポートK 制御レジスタ */
#define _PLCR 0xA4050114 /* ポートL 制御レジスタ */
#define _PMCR 0xA4050116 /* ポートM 制御レジスタ */
#define _PNCR 0xA4050118 /* ポートN 制御レジスタ */
#define _PQCR 0xA405011A /* ポートQ 制御レジスタ */
#define _PRCR 0xA405011C /* ポートR 制御レジスタ */
#define _PSCR 0xA405011E /* ポートS 制御レジスタ */
#define _PTCR 0xA4050140 /* ポートT 制御レジスタ */
#define _PUCR 0xA4050142 /* ポートU 制御レジスタ */
#define _PVCR 0xA4050144 /* ポートV 制御レジスタ */
#define _PWCR 0xA4050146 /* ポートW 制御レジスタ */
#define _PXCR 0xA4050148 /* ポートX 制御レジスタ */
#define _PYCR 0xA405014A /* ポートY 制御レジスタ */
#define _PZCR 0xA405014C /* ポートZ 制御レジスタ */

#define PACR ((volatile unsigned short*)_PACR)
#define PBCR ((volatile unsigned short*)_PBCR)
#define PCCR ((volatile unsigned short*)_PCCR)
#define PDCR ((volatile unsigned short*)_PDCR)
#define PECR ((volatile unsigned short*)_PECR)
#define PFCR ((volatile unsigned short*)_PFCR)
#define PGCR ((volatile unsigned short*)_PGCR)
#define PHCR ((volatile unsigned short*)_PHCR)
#define PJCR ((volatile unsigned short*)_PJCR)
#define PKCR ((volatile unsigned short*)_PKCR)
#define PLCR ((volatile unsigned short*)_PLCR)
#define PMCR ((volatile unsigned short*)_PMCR)
#define PNCR ((volatile unsigned short*)_PNCR)
#define PQCR ((volatile unsigned short*)_PQCR)
#define PRCR ((volatile unsigned short*)_PRCR)
#define PSCR ((volatile unsigned short*)_PSCR)
#define PTCR ((volatile unsigned short*)_PTCR)
#define PUCR ((volatile unsigned short*)_PUCR)
#define PVCR ((volatile unsigned short*)_PVCR)
#define PWCR ((volatile unsigned short*)_PWCR)
#define PXCR ((volatile unsigned short*)_PXCR)
#define PYCR ((volatile unsigned short*)_PYCR)
#define PZCR ((volatile unsigned short*)_PZCR)

#define PMOD    (0)	/* その他の機能 */
#define POUT    (1) /* 出力 */
#define PINP    (2) /* 入力 pullup 有り */
#define PIN_    (3) /* 入力 pullup 無し */
#define PORT_CONTROL(ADDRESS,P7,P6,P5,P4,P3,P2,P1,P0) \
                *(ADDRESS) = ((P7<<14) | (P6<<12) | (P5<<10) | (P4<<8) | \
                              (P3<<6)  | (P2<<4)  | (P1<<2)  | (P0))


#define _PADR 0xA4050120 /* ポートA データレジスタ */
#define _PBDR 0xA4050122 /* ポートB データレジスタ */
#define _PCDR 0xA4050124 /* ポートC データレジスタ */
#define _PDDR 0xA4050126 /* ポートD データレジスタ */
#define _PEDR 0xA4050128 /* ポートE データレジスタ */
#define _PFDR 0xA405012A /* ポートF データレジスタ */
#define _PGDR 0xA405012C /* ポートG データレジスタ */
#define _PHDR 0xA405012E /* ポートH データレジスタ */
#define _PJDR 0xA4050130 /* ポートJ データレジスタ */
#define _PKDR 0xA4050132 /* ポートK データレジスタ */
#define _PLDR 0xA4050134 /* ポートL データレジスタ */
#define _PMDR 0xA4050136 /* ポートM データレジスタ */
#define _PNDR 0xA4050138 /* ポートN データレジスタ */
#define _PQDR 0xA405013A /* ポートQ データレジスタ */
#define _PRDR 0xA405013C /* ポートR データレジスタ */
#define _PSDR 0xA405013E /* ポートS データレジスタ */
#define _PTDR 0xA4050160 /* ポートT データレジスタ */
#define _PUDR 0xA4050162 /* ポートU データレジスタ */
#define _PVDR 0xA4050164 /* ポートV データレジスタ */
#define _PWDR 0xA4050166 /* ポートW データレジスタ */
#define _PXDR 0xA4050168 /* ポートX データレジスタ */
#define _PYDR 0xA405016A /* ポートY データレジスタ */
#define _PZDR 0xA405016C /* ポートZ データレジスタ */

#define PADR ((volatile unsigned char*)_PADR)
#define PBDR ((volatile unsigned char*)_PBDR)
#define PCDR ((volatile unsigned char*)_PCDR)
#define PDDR ((volatile unsigned char*)_PDDR)
#define PEDR ((volatile unsigned char*)_PEDR)
#define PFDR ((volatile unsigned char*)_PFDR)
#define PGDR ((volatile unsigned char*)_PGDR)
#define PHDR ((volatile unsigned char*)_PHDR)
#define PJDR ((volatile unsigned char*)_PJDR)
#define PKDR ((volatile unsigned char*)_PKDR)
#define PLDR ((volatile unsigned char*)_PLDR)
#define PMDR ((volatile unsigned char*)_PMDR)
#define PNDR ((volatile unsigned char*)_PNDR)
#define PQDR ((volatile unsigned char*)_PQDR)
#define PRDR ((volatile unsigned char*)_PRDR)
#define PSDR ((volatile unsigned char*)_PSDR)
#define PTDR ((volatile unsigned char*)_PTDR)
#define PUDR ((volatile unsigned char*)_PUDR)
#define PVDR ((volatile unsigned char*)_PVDR)
#define PWDR ((volatile unsigned char*)_PWDR)
#define PXDR ((volatile unsigned char*)_PXDR)
#define PYDR ((volatile unsigned char*)_PYDR)
#define PZDR ((volatile unsigned char*)_PZDR)



#define _PSELA   0xA405014E /* ピンセレクトレジスタA           16 */
#define _PSELB   0xA4050150 /* ピンセレクトレジスタB           16 */
#define _PSELC   0xA4050152 /* ピンセレクトレジスタC           16 */
#define _PSELD   0xA4050154 /* ピンセレクトレジスタD           16 */
#define _PSELE   0xA4050156 /* ピンセレクトレジスタE           16 */
#define _HIZCRA  0xA4050158 /* I/O バッファHi-Z 制御レジスタA  16 */
#define _HIZCRB  0xA405015A /* I/O バッファHi-Z 制御レジスタB  16 */
#define _HIZCRC  0xA405015C /* I/O バッファHi-Z 制御レジスタC  16 */
#define _HIZCRD  0xA405015E /* I/O バッファHi-Z 制御レジスタD  16 */
#define _MSELCRA 0xA4050180 /* モジュール機能選択レジスタA     16 */
#define _MSELCRB 0xA4050182 /* モジュール機能選択レジスタB     16 */
#define _PULCR   0xA4050184 /* プルアップ制御レジスタ          16 */
#define _DRVCRA  0xA405018A /* I/O バッファDrive 制御レジスタA 16 */
#define _DRVCRB  0xA405018C /* I/O バッファDrive 制御レジスタB 16 */
#define _DRVCRC  0xA405018E /* I/O バッファDrive 制御レジスタC 16 */

#define PSELA   ((volatile unsigned short*)_PSELA  )
#define PSELB   ((volatile unsigned short*)_PSELB  )
#define PSELC   ((volatile unsigned short*)_PSELC  )
#define PSELD   ((volatile unsigned short*)_PSELD  )
#define PSELE   ((volatile unsigned short*)_PSELE  )
#define HIZCRA  ((volatile unsigned short*)_HIZCRA )
#define HIZCRB  ((volatile unsigned short*)_HIZCRB )
#define HIZCRC  ((volatile unsigned short*)_HIZCRC )
#define HIZCRD  ((volatile unsigned short*)_HIZCRD )
#define MSELCRA ((volatile unsigned short*)_MSELCRA)
#define MSELCRB ((volatile unsigned short*)_MSELCRB)
#define PULCR   ((volatile unsigned short*)_PULCR  )
#define DRVCRA  ((volatile unsigned short*)_DRVCRA )
#define DRVCRB  ((volatile unsigned short*)_DRVCRB )
#define DRVCRC  ((volatile unsigned short*)_DRVCRC )
