/*
 * timer.h
 */

struct tmu_dev{
	unsigned long base;
	volatile unsigned char *tstr;
	int tstr_bit;
};


extern volatile unsigned long jiffies;

void timer_start_ch(int ch);
void timer_stop_ch(int ch);
void timer_init_ch(int ch, int msec);

void timer_irq_disable(int ch);
void timer_irq_enable(int ch);

void timer_init(void);

void msleep(int msec);
void usleep(int usec);
