#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <errno.h>

void my_puts(char *p)
{
	write(0,p,strlen(p));
}


int main()
{
	int i;
	char *p;
	char str[256];

	printf("hello malloc test3 \n");

	for(i=0; ; i++){
		p=malloc(64*1024);	// 64k byte
		if(p==NULL){
			perror("malloc() fail ");
			break;
		}

		// Cライブラリによるprintf()の遅延出力を避けるため
		// 直接標準出力へ write() している
		sprintf(str,"i=%d, %0p\n", i, p);
		my_puts(str);	
	}

/* 無限ループ */
	my_puts("FINISH");

	while(1){
		malloc_stats();
		sleep(60);
	}
}

