#include <stdio.h>
#include <time.h>
#include <sys/time.h>

void print_time(void)
{
	struct timeval tv;
	struct tm tm;
	gettimeofday(&tv, NULL);
	localtime_r(&tv.tv_sec, &tm);

	printf("%4d-%02d-%02d %02d:%02d:%02d.%6d\n",
		tm.tm_year + 1900,
		tm.tm_mon + 1,
		tm.tm_mday,
		tm.tm_hour,
		tm.tm_min,
		tm.tm_sec,
		tv.tv_usec);

}

int main()
{
	while(1){
		print_time();
		sleep(1);
	}
}
