#include <stdio.h>
#include <unistd.h> 
#include <stdlib.h>
#include <sched.h>

#include "tpulib.h"

#define EXEC_FILE "./print_hello"

#define TPU_NUM 4
struct tpudrv_dev tpudrv_dev[TPU_NUM];


int main(){
	pid_t pid;
	struct tpudrv_dev *tpu0, *tpu1;
	tpu0 = &tpudrv_dev[0];
	tpu1 = &tpudrv_dev[1];

	dev_mmap();
	tpu_init_all(tpudrv_dev);
	tpu_stop_all();
	tpu_init(tpu0);
	tpu_init(tpu1);

	// printf("sched_getscheduler() -> %d\n",sched_getscheduler(0));

/* A^CvZX */
	struct sched_param sp;
	sp.sched_priority=1;
	sched_setscheduler(0, SCHED_RR, &sp);

	// printf("sched_getscheduler() -> %d\n",sched_getscheduler(0));

/* UvZXJĂ */
	usleep(100*1000); // 100msec

	/* tpu0, tpu1 ̓X^[g */
	tpu_start_all();

	pid=fork();	/* qvZX */
	if(pid==0){
		/* qvZX */
		unsigned short tcnt = tpu_tcnt(tpu0);	/* qvZX܂ł̎Ԃv */
		tpu_set_tgra(tpu0,tcnt);	/* pXグ */
		printf("tcnt0=%d (%d usec)\n",tcnt,tpudrv_calc_usec(tpu0,tcnt));
		// printf("sched_getscheduler() -> %d\n",sched_getscheduler(0));

		/* execl("./print_hello") ̎s */
		execl(EXEC_FILE,NULL);
		perror(EXEC_FILE);	/* execl()Ɏsꍇ */
		_exit(1);
	}
	/* evZX */
	waitpid(pid);
}
