/*
 * bootloader
 *   CPG init for CAT724
 *   clock pulse generator クロック発信器 周波数逓倍/分周設定
 */

#include "cpu.h"

        .global cpg_init
cpg_init:
        mov.l   FRQCRA_A,r1       /* FRQCRA Address */
        mov.l   FRQCRA_D0,r0      /* FRQCRA Data */
        mov.l   r0,@r1

        mov.l   FRQCRB_A,r1       /* FRQCRB Address */
        mov.l   FRQCRB_D,r0       /* FRQCRB Data */
        mov.l   r0,@r1

        mov.l   FRQCRA_A,r1       /* FRQCRA Address */
        mov.l   FRQCRA_D1,r0      /* FRQCRA Data */
        mov.l   r0,@r1

cpg_init_1:
        mov.l   LSTATS_A,r1       /* LSTATS Address */
        mov.l   @r1,r0
	and     #1,r0
	tst     r0,r0
	bf	cpg_init_1
	 nop

	rts
	 nop

	.align	4

FRQCRA_A:	.long	_FRQCRA
FRQCRB_A:	.long	_FRQCRB
LSTATS_A:	.long	_LSTATS

FRQCRA_D0:	.long	0x0E053508
FRQCRA_D1:	.long	0x8E053508
FRQCRB_D:	.long	0x00000030
